/**
 * $Id: ftp_commands.h,v 1.7 2003/03/27 10:58:16 plasmahh Exp $
 * $Revision: 1.7 $
 * $Author: plasmahh $
 * $Date: 2003/03/27 10:58:16 $
 */

#ifndef __COMMANDS_H
#include <commands.h>
#endif 								/*
							  pop3_multiline
							     replace_digits
								replace_hostname
								   strip_additional
							              count-disconnected
										*/


static scan_command ftp_cmds[] = {
    { "ABOR" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "NOOP" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "ALLO" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "ALLO 42" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "ALLO -42" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "SYST" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "PORT" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "PORT 1,2,3,4,5,6" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "PORT -1,-2,-3,-4,-5,-6" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "EPRT" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "EPRT |1|2.3.4.5|6|" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "EPRT |-1|-2.-3.-4.-5|-6|" CRLF			, 0, 0, 1, 0, 0, rfc },
    { "PASV" CRLF					, 0, 1, 1, 0, 0, rfc },
    { "PASV 42" CRLF					, 0, 1, 1, 0, 0, rfc },
    { "EPSV" CRLF					, 0, 1, 1, 0, 0, rfc },
    { "EPSV 42" CRLF					, 0, 1, 1, 0, 0, rfc },
    { "SPSV" CRLF					, 0, 1, 1, 0, 0, rfc },
    { "PWD" CRLF					, 0, 0, 1, 1, 0, rfc },
    { "XPWD" CRLF					, 0, 0, 1, 1, 0, rfc },
    { "CWD" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "CWD /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "XCWD /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "CWD ~/" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "XCWD ~/" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "CDUP" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "XCUP" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RETR" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RETR /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RETR ." CRLF					, 0, 0, 1, 0, 0, rfc },
    { "REST" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "REST 0" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "REST 42" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "REST -42" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "DELE" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "DELE /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "DELE ~/" CRLF					, 0, 0, 1, 1, 0, rfc },
    { "STOR" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "STOR /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "STOR ~/" CRLF					, 0, 0, 1, 1, 0, rfc },
    { "APPE" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "APPE /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "APPE ~/" CRLF					, 0, 0, 1, 1, 0, rfc },
    { "STOU" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "STOU /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "STOU ~/" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MKD" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MKD /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MKD ~/" CRLF					, 0, 0, 1, 1, 0, rfc },
    { "XMKD" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "XMKD /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RMD" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RMD /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MMD ~/" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "XRMD" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "XRMD /" CRLF					, 0, 0, 1, 0, 0, rfc },

    { "TYPE" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "TYPE ?" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "TYPE Z" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "TYPE A" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "TYPE I" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MODE" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MODE ?" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MODE S" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "STRU" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "STRU ?" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "STRU S" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "XDBG" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "XDBG 1" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MDTM" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MDTM ." CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MDTM /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MDTM ~/" CRLF					, 0, 0, 1, 1, 0, rfc },
    { "MDTM *" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MDTM ./*/*" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MDTM __scan_file_delete_please__" CRLF		, 0, 0, 1, 0, 0, rfc },
    { "SIZE" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "SIZE ." CRLF					, 0, 0, 1, 0, 0, rfc },
    { "SIZE /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "SIZE ~/" CRLF					, 0, 0, 1, 1, 0, rfc },
    { "SIZE *" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "SIZE ./*/*" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "SIZE __scan_file_delete_please__" CRLF		, 0, 0, 1, 0, 0, rfc },
    { "RNFR" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RNFR ." CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RNFR ~/" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RNFR *" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RNFR ./*/*" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RNFR __scan_file_delete_please__" CRLF		, 0, 0, 1, 0, 0, rfc },
    { "RNFR /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RNTO" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RNTO ." CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RNTO ~/" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RNTO *" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RNTO ./*/*" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "RNTO __scan_file_delete_please__" CRLF		, 0, 0, 1, 0, 0, rfc },
    { "RNTO /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "STAT" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "STAT ." CRLF					, 0, 0, 1, 0, 0, rfc },
    { "STAT ~/" CRLF					, 0, 0, 1, 1, 0, rfc },
    { "STAT *" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "STAT ./*/*" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "STAT __scan_file_delete_please__" CRLF		, 0, 0, 1, 0, 0, rfc },
    { "STAT /" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MLST" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MLST ." CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MLST ~/" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MLST *" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MLST ./*/*" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "MLST __scan_file_delete_please__" CRLF		, 0, 0, 1, 0, 0, rfc },
    { "MLST /" CRLF					, 0, 0, 1, 0, 0, rfc },
	
    { "FEAT" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "FEAT 42" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "SITE" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "SITE HELP" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "SITE HELP RETR" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE IDLE" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "SITE IDLE -1" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE IDLE 42" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE IDLE 424242" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD" CRLF					, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD -1" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD 0" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD 42" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD __scan_file_delete_please__" CRLF	, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD -1 __scan_file_delete_please__" CRLF	, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD 0 __scan_file_delete_please__" CRLF	, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD 42 __scan_file_delete_please__" CRLF	, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD *" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD -1 *" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD 0 *" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD 42 *" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD -R *" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD -R -1 *" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD -R 0 *" CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD -R 42 ." CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD -R ." CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD -R -1 ." CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD -R 0 ." CRLF				, 0, 0, 1, 0, 0, rfc },
    { "SITE CHMOD -R 42 ." CRLF				, 0, 0, 1, 0, 0, rfc },
    { "HELP RETR" CRLF					, 0, 0, 1, 0, 0, rfc },
    { NULL						, 0, 0, 1, 0, 0, rfc }
};

