/**
 * $Id: smtpmap.h,v 1.36 2003/04/16 22:23:54 plasmahh Exp $
 * $Revision: 1.36 $
 * $Author: plasmahh $
 * $Date: 2003/04/16 22:23:54 $
 */
#ifndef __SMTPMAP_H
#define __SMTPMAP_H

#define DEFAULT_SMTP_PORT 25
#define DEFAULT_POP3_PORT 110
#define DEFAULT_FTP_PORT 21

#define DEFAULT_TRG 95
/// 3 seconds to wait for an answer
#define DEFAULT_A_TIMEOUT 30000
/// 30 seconds to wait for a connet
#define DEFAULT_C_TIMEOUT 30000
#define VERSION "0.8.234-BETA"

enum debug_level
{
    normal = 0,
    verbose = 1,
    most = 2,
    every = 3
};
#endif

#if ! defined ( __GNUC_PREREQ )
#if defined __GNUC__ && defined __GNUC_MINOR__ 
# define __GNUC_PREREQ(maj, min) \
	((__GNUC__ << 16) + __GNUC_MINOR__ >= ((maj) << 16) + (min))
#else
# define __GNUC_PREREQ(maj, min) 0
#endif
#endif

/**
 *$Log: smtpmap.h,v $
 *Revision 1.36  2003/04/16 22:23:54  plasmahh
 *preparing for release
 *
 *Revision 1.35  2003/03/13 17:30:45  plasmahh
 *Added some cool stripping stuff
 *Added pop3 scanning
 *
 *Revision 1.34  2003/02/25 18:27:36  plasmahh
 *TEST
 *
 *Revision 1.33  2003/02/25 18:24:30  plasmahh
 *tets
 *
 *Revision 1.32  2003/02/25 16:36:35  plasmahh
 *A lot of changes ;)
 *
 *Revision 1.31  2003/01/07 13:36:21  plasmahh
 *more implementation of the pop3 protocol
 *
 *Revision 1.30  2002/12/19 23:18:23  plasmahh
 *first preliminary working pop3 support
 *changed options structure heavily
 *
 *Revision 1.29  2002/12/05 19:10:30  plasmahh
 *some new fingerprints
 *
 *Revision 1.28  2002/11/06 18:49:44  plasmahh
 *some fixes and stuff... ftp implemented...
 *
 *Revision 1.27  2002/11/05 22:26:01  plasmahh
 *lates fingerprints and so
 *
 *Revision 1.26  2002/11/05 20:56:27  plasmahh
 *new stuff, now ftp should work quite good
 *
 *Revision 1.25  2002/10/31 23:12:15  plasmahh
 *changed this to beta developement !
 *
 *Revision 1.24  2002/10/21 08:38:28  plasmahh
 *begin cleanup and structure changes for smtpmap 0.8-stable
 *
 *Revision 1.23  2002/10/01 20:59:02  plasmahh
 *some new structures, to maintain multiple protocols bette
 *
 *Revision 1.22  2002/08/08 22:59:43  plasmahh
 *release changes
 *
 *Revision 1.21  2002/08/08 20:46:33  plasmahh
 *subrelease
 *
 *Revision 1.20  2002/07/24 18:06:46  plasmahh
 *some slight fixes
 *fingerprint changes and cleanups
 *default value changes
 *
 *Revision 1.19  2002/06/19 20:26:37  plasmahh
 *New release, added fingerprints
 *
 *Revision 1.18  2002/06/17 22:28:03  plasmahh
 *new release
 *
 *Revision 1.17  2002/06/17 20:52:11  plasmahh
 *New release
 *
 *Revision 1.16  2002/06/17 20:12:18  plasmahh
 *New fingerprints
 *
 *Revision 1.15  2002/06/17 15:55:22  plasmahh
 *doc changes and new release
 *
 *Revision 1.14  2002/06/17 14:04:13  plasmahh
 *Added cooler output for hostnames
 *
 *Revision 1.13  2002/06/17 12:23:48  plasmahh
 *fixed timeout bugs
 *
 *Revision 1.12  2002/06/17 06:24:55  plasmahh
 *typo(s)
 *begin implementing some advanced features, use tag before this for releases...
 *
 *Revision 1.11  2002/06/16 22:41:28  plasmahh
 *changed version number..changed version number...
 *
 *Revision 1.10  2002/06/12 23:05:06  plasmahh
 *New fingerprints
 *
 *Revision 1.9  2002/06/11 20:05:45  plasmahh
 *new release
 *
 *Revision 1.8  2002/06/11 20:04:15  plasmahh
 *fixed bad connection behaviour bug
 *
 *Revision 1.7  2002/06/11 18:56:42  plasmahh
 *new release
 *
 *Revision 1.6  2002/06/11 14:27:57  plasmahh
 *Removed some variables to get rid of noisy compiler warnings... but still the one with testcmds remains... why that ?
 *
 *Revision 1.5  2002/06/10 22:10:34  plasmahh
 *first partly working fingerprinting, moving to BETA state
 *
 *Revision 1.4  2002/06/10 10:30:01  plasmahh
 *Added capabilities for gnu longopts
 *begin migrating to new fingerprint structure
 *Added multiple target options
 *Added IP axpand capabilities
 *
 *Revision 1.3  2002/05/28 18:48:09  plasmahh
 *more and more...
 *
 *Revision 1.2  2002/04/16 20:12:12  plasmahh
 *Added some new headers
 *
 */
