/**
 * $Id: scanner_ftp.cpp,v 1.6 2003/03/27 10:58:17 plasmahh Exp $
 * $Revision: 1.6 $
 * $Author: plasmahh $
 * $Date: 2003/03/27 10:58:17 $
 */

#include "scanner_ftp.h"


scanner_ftp::~scanner_ftp()
{
}

bool scanner_ftp::load_rfc_fps (void)/*{{{*/
{
    return load_fp("ftp-fingerprints-rfc","FP_RFC",FP_Rfc,false);
}/*}}}*/

bool scanner_ftp::load_return_fps (void)/*{{{*/
{
    return load_fp("ftp-fingerprints-return","FP_RETURN",FP_Return,true);
}/*}}}*/

bool scanner_ftp::load_conf_fps (void)/*{{{*/
{
    return load_fp("ftp-fingerprints-conf","FP_CONF",FP_Conf,true);
}/*}}}*/

mstring scanner_ftp::is_server (void)/*{{{*/
{
    mstring server("Unknown");
    sock.Send ("EHLO myhost.domain.com\r\n");	// and look if Receive() == 250 = OK
    sock.Disconnect();
    return server;
}/*}}}*/

bool scanner_ftp::scan_special( long number )/*{{{*/
{
    if ( number == 2 )
    {
	do_login(username,password);
    }
    return true;
}/*}}}*/

bool scanner_ftp::scan_reconnected( long number )/*{{{*/
{
    if ( number > 2 )
    {
	do_login(username,password);
    }
    return true;
}/*}}}*/

bool scanner_ftp::do_login (const mstring& username, const mstring& password)/*{{{*/
{ 
    mstring answer;
    if ( debuglevel >= most )
    {
	cout << ". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . " << endl;
    } 

    sock.Send (mstring("USER " ) + username + mstring("\r\n"),recv_timeout);
    if ( debuglevel >= most )
    {
	cout << "SEND USER " << username << endl;
    }
    answer = get_rfc_answer();
    if ( debuglevel >= most )
    {
	cout << "RECV " << answer << endl;
    }
    sock.Send (mstring("PASS " ) + password + mstring("\r\n"),recv_timeout);
    if ( debuglevel >= most )
    {
	cout << "SEND PASS ***" << endl;
    }
    answer = get_rfc_answer();
    if ( debuglevel >= most )
    {
	cout << "RECV " << answer << endl;
	cout << ". . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . . " << endl;
    }
    return true;
}/*}}}*/

/**
 *$Log: scanner_ftp.cpp,v $
 *Revision 1.6  2003/03/27 10:58:17  plasmahh
 *new additions to stripping
 *
 *Revision 1.5  2003/02/25 19:49:29  plasmahh
 *Ok, lets release ;)
 *
 *Revision 1.4  2003/02/25 16:36:35  plasmahh
 *A lot of changes ;)
 *
 *Revision 1.3  2002/11/05 18:34:10  plasmahh
 *beta release stuff
 *
 *Revision 1.2  2002/11/04 23:45:52  plasmahh
 *first addition, implementation and changes for ftp fingerprinting
 *rfc fp fix still mising !
 *
 *Revision 1.1  2002/11/03 22:25:57  plasmahh
 *new stuff for better rfc fingerprinting and preperation for ftp support... other protocolls might follow
 *
 */
