/**
 * $Id: scanner_server.cpp,v 1.21 2003/03/29 17:00:29 plasmahh Exp $
 * $Revision: 1.21 $
 * $Author: plasmahh $
 * $Date: 2003/03/29 17:00:29 $
 */

#include "scanner_server.h"

bool scanner_server::do_scan ( const mstring& _username, const mstring& _password)/*{{{*/
{
    srandom(time(NULL));
    username = _username;
    password = _password;
    int uname_l = random() % 5 + 4;
    int hname_l = random() % 5 + 4;
    creative_username = mstring::get_random_string(uname_l);
    creative_hostname = mstring::get_random_string(hname_l);
    bool ret = true;
    command_count = 0;
    cout << endl;
    hostname_list.clear();
    strip_list.clear();
    strip_list.add("home/" + username + "/" );
    strip_list.add("home/" + username );
    strip_list.add(username);
    hostname_list.add(target_host);
    // TODO & FIXME : This must not ignore -d option, and should be better/faster for alias hostnames etc.
    hostname_list.add(small_socket::get_resolved_host(small_socket::get_resolved_ip(target_host)));
    hostname_list.add(small_socket::get_resolved_ip(target_host));
    hostname_list.add(small_socket::get_hostname());

 //   hostname_list.add(small_socket::get_resolved_host(small_socket::get_resolved_ip(small_socket::get_hostname())));
    hostname_list.add(small_socket::get_fqdn());
    if ( debuglevel >= most )
    {
	cout << "HOSTNAMES TO BE STRIPPED OUT :" << endl;
	dlliterator<mstring> hit(hostname_list);
	for ( hit.first(); hit.valid(); hit.next() )
	{
	    cout << "\"" << hit.item() << "\"" << endl;
	}
	cout << "ADDITIONALS TO BE STRIPPED OUT :" << endl;
	dlliterator<mstring> sit(strip_list);
	for ( sit.first(); sit.valid(); sit.next() )
	{
	    cout << "\"" << sit.item() << "\"" << endl;
	}
    }
    ret &= scan_init(); // Do whatever is needed to initialize the scan, like connecting and logging in and stuff...
    while ( ! scan_finished() && ret )
    {
	cout << "\r" << (double) command_count / (double) cmd_number * 100.0 << " %    " << flush;
	ret &= scan_step( ); // Does one step of the scanning. If it returns a fals, abort the scan.
    }
    cout << "\r100 %              " << flush;
    sock.Disconnect();
    return ret;
}/*}}}*/

bool scanner_server::scan_step(  )/*{{{*/
{
    mstring answer;
    mstring command;
    scan_special( command_count );

    if ( debuglevel >= most )
    {
	cout << "- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - " << endl;
    }

    if ( debuglevel >= every )
    {
	cout << "Connected ? " << sock.Connected() << endl;
    }
    command = actual_command->command;

    command = command.replace("<RND_USER>",creative_username);
    command = command.replace("<RND_HOST>",creative_hostname);

    command = command.replace("<RND_STR1>",mstring::get_random_string(random() % 5 + 4));
    command = command.replace("<RND_STR2>",mstring::get_random_string(random() % 5 + 4));
    command = command.replace("<RND_STR3>",mstring::get_random_string(random() % 5 + 4));

    if ( sock.Connected() )
    {
	sock.Send(command);
	if ( debuglevel >= most )
	{
	    cout << "-> " << command << endl;
	}
    }
    else
    {
	cout << " : " << sock.GetLastErrorMsg() << endl;
	return false;
    }


    switch ( actual_command->ctype )
    {
	case rfc:
	    {
		answer = get_rfc_answer();
		break;
	    }
	case pop:
	    {
		if ( actual_command->multiline )
		{
		    answer = get_answer_multi();
		}
		else
		{
		    answer = get_answer_single();
		}
		break;
	    }
	default:
	    {
		throw x_implemented ("Unknown Command Type (Implementation Failure ?)",__FLF__);
		return false;
	    }
    }
    
    answer = answer.replace(creative_username,"<RND_USER>");
    answer = answer.replace(creative_hostname,"<RND_HOST>");

    // Insert the Stripping stuff here.
    if ( actual_command->replace_hostname )
    {
	dlliterator<mstring> hit(hostname_list);
	for ( hit.first(); hit.valid(); hit.next() )
	{
	    answer = answer.replace( hit.item() ,"<HOSTNAME>");
	}
    }

    if ( actual_command->strip_additional )
    {
	dlliterator<mstring> sit(strip_list);
	for ( sit.first(); sit.valid(); sit.next() )
	{
	    answer = answer.strip_all_from(sit.item());
	}
    }

    if ( actual_command->replace_digits )
    {
	switch ( actual_command->ctype )
	{
	    case rfc:
	    case pop:
		{
		    mstring prefix;
		    mstring rest;
		    prefix = answer.substring(1,3);
		    rest = answer.substring(4,0);
		    answer = prefix + rest.replace_numbers("<NUM>");
		}
		break;
	    default:
		answer = answer.replace_numbers("<NUM>");
	}
    }

    if ( debuglevel >= most )
    {
	cout << "<- " << answer << endl;
    }


    sock.Receive((long unsigned int)0,(long unsigned int)0);

    if ( !sock.Connected() && ((command_count+2) != (cmd_number)))
    {
	recon_count ++;
	if ( recon_count > max_recon )
	{
	    sock.Disconnect();
	    cout << "Too many Reconnects, aborting" << endl;
	    return false;
	}

	sock.Reconnect();
	if ( !scan_reconnected( command_count ))
	{
	    return false;
	}
	else if ( actual_command->count_disconnected )
	{
	    scan_add_to_fp( answer );
	}
	else
	{
	    scan_add_to_fp( mstring() );
	}
    }
    else
    {
	scan_add_to_fp( answer );
    }

    command_count++;
    if ( debuglevel >= every )
    {
	cout << command_count << ". Result Checksum is : " << answer.checksum_sum()  << endl;
    }
    actual_command++;

    if ( scan_finished() ) sock.Disconnect();
    return true;
}/*}}}*/

mstring scanner_server::get_answer_multi( void )/*{{{*/
{
    if ( debuglevel >= every )
    {
	cout << "get_answer_multi() connected : " << sock.Connected() << endl;
    }
    mstring temp;
    mstring answer;
    mstring rest,begn;
    uint32 nocount=0;
    while ( sock.Connected() )
    {
	temp = sock.Receive(10000,recv_timeout);
	if ( debuglevel >= every ) 
	{
	    cout << "get_answer_multi() temp : \"" << temp << "\"" << endl;
	}
	if ( temp.lsearch("\n") > 0 )
	{
	    answer += temp.substring( 1, temp.lsearch("\n"));
	    break;
	}
	answer += temp;
	if (temp.length() < 3)
	{
	    nocount++;
	    if ( nocount > 5 )
	    {
		sock.Disconnect();
	    }
	}
    }

    if ( answer.length() == 0 && ! sock.Connected() )
    {
	return "";
    }
    rest = temp;

  //  cout << "ANSWER AFTER FIRST LOOP : \"" << answer << "\"" << endl;

    if ( answer.matches("-ERR"))
    {
//	cout << "matching ERR-" << endl;
	return answer;
    
    }
    else if ( answer.matches("+OK") )
    {
    }
    else
    {
	cout << "SERVER BUG nrfca09 DETECTED, TRYING TO WORK AROUND !!!(may lockup!)" << endl;
	cout << "ANSWER : \"" << answer << "\"" << endl;
    }
    
    /*
    cout << "Found ? " << (bool)rest.lsearch("\r\n.\r\n") << endl;
    cout << "Found ? " << (bool)rest.lsearch("\n.\n") << endl;
    cout << "Connected ? " << sock.Connected() << endl;
*/
    if ( debuglevel >= every )
    {
	cout << "get_answer_multi() single . rest : \"" << rest << "\"" << endl;
    }
    while ( sock.Connected() && rest.lsearch("\r\n.\r\n")==0 && rest.lsearch("\n.\n")==0 )
    {
	if ( debuglevel >= every )
	{
	    cout << "get_answer_multi() single . line connected : " << sock.Connected() << endl;
	}
	rest += sock.Receive(10000,recv_timeout);
	if ( debuglevel >= every )
	{
	    cout << "get_answer_multi() single . rest : \"" << rest << "\"" << endl;
	}
	/*
	cout << "Found ? " << (bool)rest.lsearch("\r\n.\r\n") << endl;
	cout << "Found ? " << (bool)rest.lsearch("\n.\n") << endl;
	cout << "Connected ? " << sock.Connected() << endl;
	*/
    }

    return answer;
}/*}}}*/

mstring scanner_server::get_answer_single( void )/*{{{*/
{
    mstring temp;
    mstring answer;
    uint32 nocount=0;

    if ( debuglevel >= every )
    {
	cout << "get_answer_single() connected : " << sock.Connected() << endl;
    }

    bool nrfc = false;
    while ( sock.Connected() )
    {
	temp = sock.Receive(10000,recv_timeout);
	answer += temp;
	while ( ! (answer.matches("+OK") || answer.matches("-ERR") ) && answer.length() > 0)
	{
	    mstring old(answer);
	    if ( ! nrfc )
	    {
		nrfc = true;
		cout << "SERVER BUG nrfca09 DETECTED, TRYING TO WORK AROUND !!!(may lockup!)" << endl;
		cout << "ANSWER : \"" << answer << "\"" << endl;
	    }
	    answer = answer.substring(answer.lsearch("\n")+1,0);
	    if ( answer == old ) 
	    {
		break;
	    }
	    if ( answer.lsearch("\n") <= 0 )
	    {
		continue;
	    }
	    old = answer;
	}
	if ( answer.lsearch("\n") > 0 )
	{
	    break;
	}
	if (temp.length() < 2)
	{
	    nocount++;
	    if ( nocount > 5 )
	    {
		sock.Disconnect();
	    }
	}

    }
    sock.Receive(10000,0);
    answer = answer.substring( 1, answer.lsearch("\n"));
    return answer;
}/*}}}*/

mstring scanner_server::get_rfc_answer ( void )/*{{{*/
{
    // get answer string... search for last line, then search for %%%- like rfc answers... 
    // the last line is without the -, so return if found
    mstring answer="";
    mstring temp;
    mstring last;
    int nocount = 0; // counts number of empty answers
    int code,n_code;
    code = n_code = 0;
    bool dataline = false;
    bool firstline = true;
    mstring prefix;
    mstring lastprefix;
	
    // TODO what if we are disconnected ?
    while ( sock.Connected() )
    {
	temp = sock.Receive(10000,recv_timeout);
	temp += sock.Receive(10000,50);
//	cout << "RFC : received " << temp << endl;
	if ( temp.length() == 0 ) 
	{
	    nocount++;
	    if ( nocount > 5 )
	    {
		sock.Disconnect();
		usleep (10000);
	    }
	    continue;
        }
	
	// If the line is the first received
	// 1. Extract prefix for next lines... 
	// 2. Generate prefix that should be the last line of the result
	if ( firstline )
	{
//	    cout << "The FIRST line is : \"" << temp << endl;
	    firstline = false;
	    prefix = temp.substring(1,3); 
	    lastprefix = prefix + " ";
	    prefix += "-";
//	    cout << "PREFIX \"" << prefix << "\"" << endl;
//	    cout << "LAPREF \"" << lastprefix << "\"" << endl;
	}

        while ( temp.lsearch("\n") > 0 )
	{
	    last = temp;
	    mstring line = temp.substring(0,temp.lsearch("\n"));
//	    cout << "RFC : one line is : " << temp.substring(0,temp.lsearch("\n")) << endl;
	    if ( line.matches(prefix) || line.matches(lastprefix) )
	    {
		answer += line;
		dataline = false;
	    }
	    else
	    {
		if ( ! dataline )
		{
		    answer +="<dataline(s)>\r\n";
		}
		dataline = true;
	    }
	    temp = temp.substring(temp.lsearch("\n",0)+1,0);
	}
	if ( last.matches(lastprefix) )
	{
	    break;
	}
    }
  //  cout << "RFC : complete answer : " << answer << endl;
    return answer;
}/*}}}*/

bool scanner_server::load_fp (const mstring& file, const mstring& identifier, fp_type fpt,bool check_leng)/*{{{*/
{

    mstring filename;
    filename.format ("%s/share/smtpmap/%s", _PREFIX, (const char*) file );
    mfile datei (filename);
    // Check if the file could be opened
    if (!datei.Open ())
    {
        cout << "Error opening file " << filename << endl;
        perror (NULL);
        return false;
    }

    mstring line;
    mstring version;
    mstring fp_line;

    fp *cfp = NULL;
    uint32 fps;
    uint32 lenge = 0;
    uint32 lines = 0;
    bool was = true; // false means last was a version, true means last was a fingerprint.
    bool ret = true;

    // As long as there is data, read it ;)
    while (!datei.Eof ())
    {
	line = get_next_line(datei);
        lines++; // because of this, we need a comment line to 
        if (line.length () == 0)
	    continue;		// In this case, it was only an empty line, so ignore...
        if (line.strip_all_whitespaces().matches("VERSION="))
	{
	    if (!was)		// if we have multiple lines, this was already set 
	    {
		printerror("Version line without a fingerprint found!",lines);
		ret = false;
	    }
	    was = false;
	    version = line.substring( 9,0 ); //TODO search for the = here
	}
	else if(line.strip_all_whitespaces().matches(identifier))
	{
	    if (was)
  	    {
		printerror("Fingerprint line without a Version found!",lines);
		ret=false;
	    }
	    was = true;
	    fp_line = line.substring (identifier.length()+2, 0); //TODO search for = here
	}
	else
	{
	    printerror("Invalid line found!",lines);
	    ret = false;
	}

        if ( (!ret || lenge<0) && !polite)
	{
	    datei.Close();
	    return false;
	}
	if ( !was ) continue;

	switch (fpt)
	{
	    case FP_Conf :
		cfp = new fp_conf(version);
		break;
	    case FP_Return :
		cfp = new fp_return(version);
		break;
	    case FP_Rfc :
		cfp = new fp_rfc(version);
		break;
	    case FP_Pop3 :
	    case FP_Ftp  :
	    case FP_Imap :
	    case FP_Base :
		throw x_implemented("Trying to load non-existend fingerprint types",__FLF__);
		break;
	}

        fps = gen_fp_data (cfp, fp_line);
	if (fps <= 0)	// In this case, there was an error during generation
	{
	    printerror("Invalid FP_CONF line found",lines);
	    ret = false;//if (polite) { continue; } else { return false; }
	}

	if ( debuglevel >= every )
	{
	    cout << "Found this fingerprint : " << endl;
	    switch (fpt)
	    {
		case FP_Conf :
		    cout << *((fp_conf*)cfp) << endl;
		    break;
		case FP_Return :
		    cout << *((fp_return*)cfp) << endl;
		    break;
		case FP_Rfc :
		    cout << *((fp_rfc*)cfp) << endl;
		    break;
		case FP_Pop3 :
		case FP_Ftp  :
		case FP_Imap :
		case FP_Base :
		    throw x_implemented("Trying to load non-existend fingerprint types",__FLF__);
		    break;
	    }
	}
	
	add_fp(*cfp,fpt);

	delete cfp;
	if ( check_leng )
	{
	    try
	    {
		lenge = check_lenge (lenge, fps, lines,polite );
	    } 
	    catch(...)
	    {
		ret = false;
	    }
	}
    }
    datei.Close();
    return true;
}/*}}}*/

uint32 scanner_server::check_lenge (uint32 lenge, uint32 fps, uint32 lines ,bool polite)/*{{{*/
{
    if (lenge == 0)
    {
	lenge = fps;
    }
    else if (lenge != fps)
    {
	printerror( "FP Size does not match previously ones.", lines);
	throw(-1);
    }

    return lenge;
}/*}}}*/

void scanner_server::printerror( const mstring & error, uint32 line )/*{{{*/
{
    cout << "Error in line " << line << " : " << error;
    if (polite)
    {
	cout << " ( --polite set, ignoring ) " << endl;
    }
    else
    {
	cout << endl;
    }
}/*}}}*/

sint32 scanner_server::gen_fp_data (fp * cfp, mstring & fp)/*{{{*/
{
    uint32 nk=0;
    uint32 fps=0;
    uint32 sfp=0;
    char * end=NULL;
    mstring num;

    do
    {
	nk = fp.lsearch (",");
	num = fp.substring (1, nk - 1);
	fp = fp.substring (nk + 1, 0);
	fps++;
	sfp = strtol (num, &end, 10);
	if ( end != num[num.length()] )
	{
	    return -1;
	}
	// generate a more elaborate version of this stuff here 
	cfp->add (sfp);
    }
    while (fp.lsearch (",") > 0);

    sfp = strtol (fp, NULL, 10);
    cfp->add (sfp);
    return fps;
}/*}}}*/

mstring scanner_server::get_next_line ( mfile& datei)/*{{{*/
{
    mstring line;
    int rpos;
    line = datei.ReadLine().strip_whitespaces();
    rpos = line.lsearch("#");
    if (rpos == 1) return mstring("");
    line = line.substring(1,rpos-1);
    return line.strip_whitespaces();
}/*}}}*/

bool scanner_server::scan_finished( void )/*{{{*/
{
        return ( ! actual_command->command );
}/*}}}*/


/**
 *$Log: scanner_server.cpp,v $
 *Revision 1.21  2003/03/29 17:00:29  plasmahh
 *new features
 *
 *Revision 1.20  2003/03/27 10:58:17  plasmahh
 *new additions to stripping
 *
 *Revision 1.19  2003/03/13 17:30:45  plasmahh
 *Added some cool stripping stuff
 *Added pop3 scanning
 *
 *Revision 1.18  2003/02/25 23:23:46  plasmahh
 *fixed pop3 scanner bug
 *workaround for buggy rfc response servers
 *
 *Revision 1.17  2003/02/25 21:43:35  plasmahh
 *this or that
 *
 *Revision 1.16  2003/02/25 19:49:29  plasmahh
 *Ok, lets release ;)
 *
 *Revision 1.15  2003/02/25 16:36:35  plasmahh
 *A lot of changes ;)
 *
 *Revision 1.14  2003/01/27 16:53:52  plasmahh
 *migrating build system to athlon
 *
 *Revision 1.13  2002/11/25 23:33:35  plasmahh
 *changed a bit stuff and new fingerprints and and and ;)
 *
 *Revision 1.12  2002/11/06 18:49:45  plasmahh
 *some fixes and stuff... ftp implemented...
 *
 *Revision 1.11  2002/11/05 20:56:27  plasmahh
 *new stuff, now ftp should work quite good
 *
 *Revision 1.10  2002/11/04 23:45:52  plasmahh
 *first addition, implementation and changes for ftp fingerprinting
 *rfc fp fix still mising !
 *
 *Revision 1.9  2002/10/21 08:38:29  plasmahh
 *begin cleanup and structure changes for smtpmap 0.8-stable
 *
 *Revision 1.8  2002/10/01 20:59:02  plasmahh
 *some new structures, to maintain multiple protocols bette
 *
 *Revision 1.7  2002/08/12 13:13:05  plasmahh
 *removed some memory leaks
 *
 *Revision 1.6  2002/08/08 22:13:46  plasmahh
 *fixed bug with really fast connecting
 *
 *Revision 1.5  2002/08/08 21:57:57  plasmahh
 *DEBUG !!!
 *
 *Revision 1.4  2002/08/08 21:47:28  plasmahh
 *more debug
 *
 *Revision 1.3  2002/06/18 13:42:39  plasmahh
 *fixed timeout behaviour
 *new fingerprints added
 *improved documentation
 *
 *Revision 1.2  2002/06/17 20:41:10  plasmahh
 *fixed little bug
 *
 *Revision 1.1  2002/06/17 12:23:48  plasmahh
 *fixed timeout bugs
 *
 */
