/* (C)opright 2001 by PlasmaHH <plasmahh@gmx.net> */
/**
 * $Id: smtpmap.cpp,v 1.47 2003/03/27 10:58:17 plasmahh Exp $
 * $Revision: 1.47 $
 * $Author: plasmahh $
 * $Date: 2003/03/27 10:58:17 $
 */
#include <iostream>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <time.h>
#include <string.h>
#include <getopt.h>


// new c++ includes/*{{{*/
#ifndef __FP_CONF_H
#include "fp_conf.h"
#endif 

#ifndef __FP_RFC_H 
#include "fp_rfc.h"
#endif

#ifndef __FP_RETURN_H
#include "fp_return.h"
#endif

#ifndef __MSTRING_H
#include "mstring.h"
#endif

#ifndef __DLLIST_H
#include "dllist.h"
#endif

#ifndef __SMALL_SOCKET_H
#include "small_socket.h"
#endif

#ifndef __SCANNER_SMTP_H
#include "scanner_smtp.h"
#endif

#ifndef __SCANNER_FTP_H
#include "scanner_ftp.h"
#endif 

#ifndef __SCANNER_POP3_H
#include "scanner_pop3.h"
#endif 

#ifndef __PARSING_H
#include "parsing.h"
#endif/*}}}*/

// for some defaults
#include "smtpmap.h"

// some data structures that will be needed.../*{{{*/

/** 
 * double linked list, that will hold all the targets 
 * we have to scan (IP addresses & hostnames, will be 
 * converted during run to ip adresses only)
 */
dllist< mstring > usertargets;

/**
 * double linked list that will hold the real targets 
 * to be scanned
 */
dllist< mstring > scantargets;

/**
 * this is our connection to the outer world, we reuse 
 * it for every scanned host. Perhaps we will do something like
 * multithreading/multiconnection in a far future version... perhaps....
 */

small_socket connection;

/**
 *
 */

dllist < fp_return > allreturns;
dllist < fp_conf   > allconfs;
dllist < fp_rfc    > allrfcs;

mstring smtp_username ( "anonymous" );
mstring ftp_username ( "anonymous" );
mstring pop3_username ( "anonymous" );

mstring smtp_password( "anony_user@nononet.org");
mstring ftp_password( "anony_user@nononet.org");
mstring pop3_password( "anony_user@nononet.org");
// define global and default options
double trg  = DEFAULT_TRG;

debug_level debuglevel=normal;
uint32 conn_timeout = DEFAULT_C_TIMEOUT;
uint32 recv_timeout = DEFAULT_A_TIMEOUT;
uint16 smtp_port = DEFAULT_SMTP_PORT; 
uint16 ftp_port = DEFAULT_FTP_PORT;
uint16 pop3_port = DEFAULT_POP3_PORT;

bool scan_smtp 	= false;
bool scan_ftp 	= false;
bool scan_pop3 	= false;
bool nodns 	= false;
bool polite 	= false;
bool dofast 	= false;
bool printbanner = true;
bool stripadvanced = false;
/*}}}*/

bool expandhostlist ( void )/*{{{*/
{
    // This will expand all the host into a list of IPs, and save it.
    // With big lists, this will consume lots of memory, *.*.*.* at least will crash the 
    // program with an out of mem error.
    // We don't expand during the run, since even 10000 hosts will not consume so much memory,
    // but scanning needs so much time, that higher amounts make no sence
    // cout << "expanding hostlist to scannable IP list... taking non-expandable IP ranges as hostnames.... " << endl;
    dlliterator<mstring> uit(usertargets);
    for ( uit.first(); uit.valid(); uit.next() )
    {
	try {
		// try to parse the IP-range....
		scantargets += parsing::expand_iplist( uit.item() );
	    }
	    catch (Exception& e)
	    {
		e.handled();
		// it was not possible to parse it, so take it just as a hostname...
		scantargets.add( uit.item() );
	    }
    }
    if ( debuglevel > 2 )
    {
	cout << "The following is a list of hosts to be scanned : " << endl;
	dlliterator< mstring > scanit(scantargets);
	for ( scanit.first() ; scanit.valid(); scanit.next() )
        {
	    cout << scanit.item() << endl;
        }
    }
    return true;
}/*}}}*/

bool scan_do( scanner_server& scn, mstring& target, uint16 port, mstring& u, mstring& p)/*{{{*/
{
	scn.set_target ( target, port );
	if ( dofast )
	{
	    cout << " : " << scn.is_server();
	    return true;
	}
	else
	{
	    return scn.do_scan(u,p);
	}
}/*}}}*/

int scan( ) // manage the actual scan/*{{{*/
{
    cout << endl;
    int rtn = 0;
    /*
     * Ok, we iterate through all our hosts, dns them or so, and initiate a
     * scan for all of them...  Until here, all the option stuff will be done I
     * guess, so here we initialize our first scanning module If this failes ,
     * we return ...
     */
    small_socket mysock;
    /*
     *  I guess the scanner can remain in this function as a local object... it
     *  will feed with the socket, and The targets will be set in a loop... we
     *  should give the outputting & sorting for the single hosts to another
     *  function
     */
    scanner_smtp scn(mysock,debuglevel,polite, conn_timeout, recv_timeout);
    scanner_ftp fscn(mysock,debuglevel,polite, conn_timeout, recv_timeout);
    scanner_pop3 pscn(mysock,debuglevel,polite, conn_timeout, recv_timeout);
    // if init fails, return.
    if ( ! scn.initialize() || ! fscn.initialize() || ! pscn.initialize() ) 
    {
	return -1;
    }

    expandhostlist();
    dllist < mstring > descs;
    dllist < dllist < fp >  > results;
    dllist < fp > actual;

    dlliterator<mstring> sit ( scantargets );
    mstring rhost, rip;
    for (sit.first();sit.valid();sit.next())
    {
	cout << "Scanning " << sit.item() << " ( ";
	if ( ! nodns )
	{
	    rip   = small_socket::get_resolved_ip  (sit.item());
	    rhost = small_socket::get_resolved_host(sit.item());
	}

	if ( sit.item() != rip && rip.length() != 0)
	{
	    cout << "[ " << rip << " ] ";
	}

	if ( sit.item() != rhost && rhost.length() != 0 )
	{
	    cout << rhost;
	}

	cout << " )";


        if ( debuglevel > 1 )
	{
	    cout << "\nResult of the fast scan " << endl;
	}

	descs.clear();
	results.clear();

	if ( scan_smtp )
	{
	    if ( ! scan_do(  scn, sit.item(), smtp_port, smtp_username,smtp_password) )
	    {
		rtn = -1;
	    }
	    else if (!dofast)
	    {
		scn.finalize();
		results += scn.get_fps();
		descs += scn.get_descs();
	    }
	}

	if ( scan_ftp )
	{
	    if ( ! scan_do(  fscn, sit.item(), ftp_port, ftp_username,ftp_password) )
	    {
		rtn = -1;
	    }
	    else if (!dofast)
	    {
		fscn.finalize();
		results += fscn.get_fps();
		descs += fscn.get_descs();
	    }
	}

	if ( scan_pop3 )
	{
	    if ( ! scan_do( pscn, sit.item(), pop3_port, pop3_username, pop3_password) )
	    {
		rtn = -1;
	    }
	    else if (!dofast)
	    {
		pscn.finalize();
		results += pscn.get_fps();
		descs += pscn.get_descs();
	    }
	}
	
	if ( debuglevel > 2)
	{
	    cout << "Got " << results.size() << " fingerprints types" << endl;
	}
	dlliterator<mstring> dit(descs);
	dlliterator< dllist <fp> > fit(results);
	// As a definition result of the scanner, tnumber of description should
	// match the number of fp-lists
	fit.first();
	actual.set_sort_mode(up); /* setting the sort mode to down will cause
				     the fps with the highest values to be at
				     the end, so the best matching are at the
				     beginning */

	int maxerr,err;
	double errval;
	int outnmb = 0;
	mstring ver;
	if (dofast)
	{
	    cout << endl;
	    continue;
	}
	cout << endl;
	for ( dit.first() ; dit.valid(); dit.next() )
	{
	    cout << "According to " << dit.item() << " the server matches the following : " << endl;
	    cout << "  Version \t\t\t\t\tProbability" << endl;
	    actual.set_sort_mode(up);
	    actual = fit.item();
	    dlliterator< fp > ffi(actual);
	    ffi.last();
	    maxerr = ffi.item().Error();
	    outnmb = 0;
	    for ( ffi.first() ; ffi.valid(); ffi.next() )
	    {
		outnmb++;
		err = ffi.item().Error();
		errval = 100.0 - ((double)err / (double)maxerr)*100.0;
		if ( outnmb > 3 && errval < trg ) 
		{
		    break;
		}
 
		ver = ffi.item().Version() + "                                                ";
		ver = ver.substring(1,47);
		cout << ver << " " << errval << " % "<< endl;

		if ( debuglevel > 2 )
		{
		    cout << maxerr << " -> " << err << endl;
		}
	    }
	    cout << endl;
	    fit.next();
	}
    }
    return rtn;            
};/*}}}*/

void help(void) // print out usage information/*{{{*/
{
    cout << "smtpmap Version " << VERSION << " - A tool to scan smtp (ftp, pop3 & imap) Servers" <<  endl;
    cout << endl;
    cout << "Usage: smtpmap [OPTIONS]... HOST"  << endl;
    cout << endl; 
    cout << endl;
    cout << "    -F, --ftp           Scan a ftp Server." << endl;
    cout << "    -P, --pop3          Scan a pop3 Server." << endl;
    cout << "    -S, --smtp          Scan a smtp Server (defaults to this if none" << endl;
    cout << "                        of the 3 is given)." << endl;
    cout << "    -h, --help          This nice help screen." << endl;
    cout << "    -V, --version       Output \"" << VERSION << "\"" << endl;
    cout << "    -v, --verbose       Be Verbose (Up to three times for max. verbosity)." << endl;
    cout << "    -p, --polite        Be polite when reading database and options." << endl;
    cout << "    -d, --nodns         Don't do any DNS lookups if possible." << endl;
    cout << "    -f, --fast          Do a fast probe (No Fingerprint scans)." << endl;

    cout << "    -c, --conn_timeout <secs> The time after which a connection attempt" << endl;
    cout << "                        is considered as failed." << endl; 
    cout << "    -t, --timeout <secs> Time after which a request times out (when connected)." << endl;
    cout << "    -n, --trigger <perc> Only results that match above perc are shown." << endl;
    cout << endl;
    cout << "    --ftp-port  <port>  An alternative port the FTP Scan should go to." << endl;
    cout << "    --smtp-port <port>  An alternative port the SMTP Scan should go to." << endl;
    cout << "    --pop3-port <port>  An alternative port the POP3 Scan should go to." << endl;
    cout << "    --ftp-user  <user>  An alternative user for FTP scan (default : anonymous)." << endl;
    cout << "    --smtp-user <user>  An alternative user for SMTP scan (default : anonymous)." << endl;
    cout << "    --pop3-user <user>  An alternative user for POP3 scan (default : anonymous)." << endl;
    cout << "    --ftp-pass  <pass>  An alternative password for the FTP scan" << endl;
    cout << "                        (default : anony_user@nononet.org)." << endl;
    cout << "    --smtp-pass <pass>  An alternative password for the SMTP scan" << endl;
    cout << "                        (default : anony_user@nononet.org)." << endl;
    cout << "    --pop3-pass <pass>  An alternative password for the POP3 scan" << endl;
    cout << "                        (default : anony_user@nononet.org)." << endl;
    cout << endl;
    cout << "HOST can be a name to be resolved, an IP or even an IP Range in the form " << endl;
    cout << "192.168.1-40.*" << endl;

}/*}}}*/

void parseoptions(int argc, char *argv[]) // parse command line options/*{{{*/
{
    int fodder,prt;
    debuglevel = normal;
    // for 1. field : no_argument=0, required_argument=1 and
    // optional_argument=2 last is a flag, dont know which, but NULL works.
    // last is the option given back, so set to the same as short options...

    option myopts[] = {
	{"ftp-port", 	1, NULL, 500},
	{"ftp-user", 	1, NULL, 501},
	{"ftp-pass", 	1, NULL, 502},
	{"smtp-port", 	1, NULL, 600},
	{"smtp-user", 	1, NULL, 601},
	{"smtp-pass", 	1, NULL, 602},
	{"pop3-port", 	1, NULL, 700},
	{"pop3-user", 	1, NULL, 701},
	{"pop3-pass", 	1, NULL, 702},
	{"trigger",	1, NULL, 'n'},
	{"timeout",	1, NULL, 't'},
	{"conn_timeout",1, NULL, 'c'},
	{"nodns",	0, NULL, 'd'},
	{"ftp",		0, NULL, 'F'},
	{"pop3",	0, NULL, 'P'},
	{"smtp",	0, NULL, 'S'},
	{"help",	0, NULL, 'h'},
	{"polite",	0, NULL, 'p'},
	{"fast", 	0, NULL, 'f'},
	{"verbose", 	0, NULL, 'v'},
	{"version",	0, NULL, 'V'},
	{NULL,		0, NULL, 0  }
			};
    // perhaps add something like --polite=true/yes or so to a future version ;)

    while ( (fodder = getopt_long(argc, argv, "n:t:c:dFPShpfvV",myopts,NULL)) != EOF) 
    {
	//cout << "Fodder : " << fodder << endl;
	switch(fodder) 
	{
	    case 'n':
		trg = strtod(optarg, NULL);
		break;
	    case 't':
		recv_timeout = strtol ( optarg, NULL, 10) * 1000;
		if ( recv_timeout < 1 )
		{
		    cerr << "Invalid value for --timeout specified" << endl;
		    exit(EXIT_FAILURE);
		}
		break;
	    case 'c':
		conn_timeout = strtol ( optarg, NULL, 10) * 1000;
		if ( conn_timeout < 1 )
		{
		    cerr << "Invalid value for --conn_timeout specified" << endl;
		    exit(EXIT_FAILURE);
		}
		break;
	    case 'd':
		nodns = true;
		break;
	    case 'F':
		scan_ftp = true;
		break;
	    case 'P':
		scan_pop3 = true;
		break;
	    case 'S':
		scan_smtp = true;
		break;
	    case 'h':
		help();
		exit(EXIT_SUCCESS);
	    case 'p':
		polite = true;
		break;
	    case 'f':
		dofast = true;
		break;
	    case 'v':
		if (debuglevel == every) 
		{ 
		    cout << "Note: More than -v -v -v will not produce more verbositiy" << endl; 
		    break;
		}
		((int)debuglevel)++;
		break;
	    case 'V':
		cout << "smtp-map " << VERSION << endl;
		exit(EXIT_SUCCESS);
		break;
	    case 500:
		prt = atoi(optarg);
		if ( prt <= 0 || prt > 65535 )
		{
		    cerr << "Invalid value for --ftp-port specified" << endl;
		    exit ( EXIT_FAILURE );
		}
		ftp_port = prt;
		break;
	    case 501:
		ftp_username = optarg; 
		break;
	    case 502:
		ftp_password = optarg;
		break;
	    case 600:
		prt = atoi(optarg);
		if ( prt <= 0 || prt > 65535 )
		{
		    cerr << "Invalid value for --smtp-port specified" << endl;
		    exit ( EXIT_FAILURE );
		}
		smtp_port = prt;
		break;
	    case 601:
		smtp_username = optarg; 
		break;
	    case 602:
		smtp_password = optarg;
		break;
	    case 700:
		prt = atoi(optarg);
		if ( prt <= 0 || prt > 65535 )
		{
		    cerr << "Invalid value for --pop3-port specified" << endl;
		    exit ( EXIT_FAILURE );
		}
		pop3_port = prt;
		break;
	    case 701:
		pop3_username = optarg; 
		break;
	    case 702:
		pop3_password = optarg;
		break;
	    default:
   		if ( optarg != NULL ) 
		{ 
		    cerr << "Unknown option : " << optarg << endl; 
		}
		else 
		{ 
		    break; 
		}
		help();
		exit(EXIT_FAILURE);
	}// of switch
    }// of while

    while ( optind < argc )
    {
	usertargets.add( argv[optind] );
	optind++;
    };
// print debug output TODO write all the other options too ;)
    if (debuglevel >= most)
    {
	cout << " Server(s) to be scanned : " << endl;
	dlliterator< mstring > uit(usertargets);
	for ( uit.first(); uit.valid(); uit.next() )
	{
	    cout << uit.item() << endl;
	}

	cout << "Services to be scanned :";
	cout << (scan_ftp ? " FTP " : "" );
	cout << (scan_smtp ? " SMTP " : "" );
	cout << (scan_pop3 ? " POP3 " : "" );
	cout << endl;

    };

}/*}}}*/

// ********************************************************************************************
// **************************************** MAIN **********************************************
// ********************************************************************************************
int main(int argc, char *argv[])/*{{{*/
{
#if __GNUC_PREREQ(3,0)
    cout << boolalpha;
#endif
    int scanresult = -1;		// saves return value of the server scan
    parseoptions(argc, argv);
    cout << "smtp-map " << VERSION << endl;
    // If no server was given we can't do anything so quit
    if ( usertargets.size() <= 0 )
    {
	cerr << "Can't locate a target server in your options" << endl;
	cerr << "Valid options are : " << endl;
	help();
	return EXIT_FAILURE;
    }

    if ( !scan_smtp && !scan_ftp && !scan_pop3)
    {
	scan_smtp = true;
	if ( debuglevel > 1 )
	{
	    cout << "No scan given, defaulting to smtp" << endl;
	}

    }
    // Do the actual scan.
    try 
    {
	scanresult = scan ( );
    }
    catch ( Exception & e)
    {
	return -1;
    }

    if ( scanresult != 0)
    {
	cerr << "Error during the scan !!" << endl;
	if (debuglevel > 2) { cout << "scan() return value : " << scanresult << endl; };
	return EXIT_FAILURE;
    }
    cout << "\nIf you know the name of the SMTP/FTP/POP3 server software you just have" << endl;
    cout << "scanned, please contribute to this program by sending the whole output with" << endl;
    cout << " -v -v and name of the server software to : plasmahh@gmx.net" << endl;
    cout << "(please also specify if relay was possible, user logged in, was anonymous," << endl; 
    cout << "or if user had mail) If the server is accesible from within the internet," << endl;
    cout << "you could also give adress, if possible." << endl;
    return 0;
}/*}}}*/

/**
 *$Log: smtpmap.cpp,v $
 *Revision 1.47  2003/03/27 10:58:17  plasmahh
 *new additions to stripping
 *
 *Revision 1.46  2003/02/25 18:27:39  plasmahh
 *TEST
 *
 *Revision 1.45  2003/02/25 17:31:28  plasmahh
 *test
 *
 *Revision 1.44  2003/02/25 16:36:35  plasmahh
 *A lot of changes ;)
 *
 *Revision 1.43  2003/01/07 13:36:22  plasmahh
 *more implementation of the pop3 protocol
 *
 *Revision 1.42  2002/12/19 23:18:23  plasmahh
 *first preliminary working pop3 support
 *changed options structure heavily
 *
 *Revision 1.41  2002/11/25 23:33:35  plasmahh
 *changed a bit stuff and new fingerprints and and and ;)
 *
 *Revision 1.40  2002/11/12 14:51:04  plasmahh
 *new fingerprints mainly
 *
 *Revision 1.39  2002/11/05 20:56:27  plasmahh
 *new stuff, now ftp should work quite good
 *
 *Revision 1.38  2002/11/05 18:34:10  plasmahh
 *beta release stuff
 *
 *Revision 1.37  2002/11/05 00:39:47  plasmahh
 *schluss fr heute
 *
 *Revision 1.36  2002/11/05 00:31:10  plasmahh
 *fixed rfc fingerprinting
 *
 *Revision 1.35  2002/11/03 23:09:42  plasmahh
 *fixed new rfc fingerptinting, and began collecting fingerprints for it
 *
 *Revision 1.34  2002/11/03 22:26:00  plasmahh
 *new stuff for better rfc fingerprinting and preperation for ftp support... other protocolls might follow
 *
 *Revision 1.33  2002/10/21 08:38:29  plasmahh
 *begin cleanup and structure changes for smtpmap 0.8-stable
 *
 *Revision 1.32  2002/10/16 23:06:17  plasmahh
 *new function for reading fingerprints from file
 *fixes some stuff
 *
 *Revision 1.31  2002/08/14 20:01:19  plasmahh
 *intermediate release
 *
 *Revision 1.30  2002/08/12 13:13:05  plasmahh
 *removed some memory leaks
 *
 *Revision 1.29  2002/07/24 18:06:47  plasmahh
 *some slight fixes
 *fingerprint changes and cleanups
 *default value changes
 *
 *Revision 1.28  2002/06/20 21:17:21  iceblox
 *Checked the language and prolly broke some functions ;)
 *
 *Revision 1.27  2002/06/20 20:37:01  plasmahh
 *new fingerprints
 *fixed correct fingerprinting on multiple hosts
 *
 *Revision 1.26  2002/06/17 21:50:05  plasmahh
 *removed warning while compiloing
 *
 *Revision 1.25  2002/06/17 16:44:22  plasmahh
 *fixed parsing of timeout options
 *
 *Revision 1.24  2002/06/17 14:21:35  plasmahh
 *Cooler display ;)
 *
 *Revision 1.23  2002/06/17 14:04:13  plasmahh
 *Added cooler output for hostnames
 *
 *Revision 1.22  2002/06/17 06:24:56  plasmahh
 *typo(s)
 *begin implementing some advanced features, use tag before this for releases...
 *
 *Revision 1.21  2002/06/16 21:30:04  plasmahh
 *slight fixes
 *
 *Revision 1.20  2002/06/12 20:21:27  plasmahh
 *fixed segfault for timeout value
 *
 *Revision 1.19  2002/06/12 14:39:34  plasmahh
 *new fingerprints
 *beautified output
 *
 *Revision 1.18  2002/06/12 14:12:08  plasmahh
 *fingerprint cleanup
 *
 *Revision 1.17  2002/06/11 20:04:15  plasmahh
 *fixed bad connection behaviour bug
 *
 *Revision 1.16  2002/06/11 18:54:35  plasmahh
 *fixed timeout behaviour, need only to fix reconnects...
 *new fingerprint
 *
 *Revision 1.15  2002/06/11 14:27:57  plasmahh
 *Removed some variables to get rid of noisy compiler warnings... but still the one with testcmds remains... why that ?
 *
 *Revision 1.14  2002/06/11 06:17:31  plasmahh
 *compiles now even on cygwin !
 *
 *Revision 1.13  2002/06/10 22:54:45  plasmahh
 *fixed wrong calculation of results
 *
 *Revision 1.12  2002/06/10 22:10:35  plasmahh
 *first partly working fingerprinting, moving to BETA state
 *
 *Revision 1.11  2002/06/10 19:43:27  plasmahh
 *Added sample fingerprints for testing
 *
 *Revision 1.10  2002/06/10 11:56:17  plasmahh
 *scanning of the hosts is done, implementation of comparing & ranking is still missing
 *
 *Revision 1.9  2002/06/10 10:30:01  plasmahh
 *Added capabilities for gnu longopts
 *begin migrating to new fingerprint structure
 *Added multiple target options
 *Added IP axpand capabilities
 *
 *Revision 1.8  2002/05/28 18:48:09  plasmahh
 *more and more...
 *
 *Revision 1.7  2002/05/14 16:31:59  plasmahh
 *implementing new scanner structure, that will be   e xtendible
 *
 *Revision 1.6  2002/05/13 14:36:42  plasmahh
 *Added new scanner technologies to plug in new scanners in the future
 *
 *Revision 1.5  2002/05/06 21:27:44  plasmahh
 *redesigned the classes a bit...
 *begin  implementing main & static
 *
 *Revision 1.4  2002/05/01 23:08:50  plasmahh
 *mh...
 *
 *Revision 1.3  2002/04/30 06:04:35  plasmahh
 *minor documentation changes
 *
 *Revision 1.2  2002/04/16 20:10:24  plasmahh
 *Added new headers
 *
 */
